Hello everyone,

At March 11 there was an annual programming contest in Samara University, and yet again we copy it into Codeforces Gyms. The gym contest takes place on Sunday, March 18, at 11:00 MSK.

Third time in a row it is a personal contest. So we ask everyone to participate solo. The contest is the most interesting for blue and violet coders.

And as usual,

**The list of our previous contests**

Can I register with my team? Or only individual contestants?

You can, but people on the onsite contest played individually.

Will there be an editorial after the contest. It becomes really hard to get solutions for all the problems from the comments for beginners like me.

I enjoyed the contest, the problems were really interesting. Can I see the case I'm failing at on problem M?

This test has n = 3.

I'm like brute forcing, so maybe it's some logical bug.

Can you share the full test? :)

Can someone share his code for C.

Code

I'm not sure how clear it is but I can explain anything if it's unclear.

Could you please explain how your code works. This is my Code. The Idea is same as yours I guess but its giving wrong answer on Test 11.

I start by sorting the ranges by their end points. Then as I'm processing the end points, ill greedily build my set.

Basically, if by the time I get to the end of some range and there's no number in my set (that's the ceiling() call) that belongs in it's range, then I'll add that range's endpoint to the set.

This is always optimal because I'm going in increasing order of endpoints so every time I add a number to my set, it's as large as possible so it's most likely to fit in the other ranges (who all have end points greater than the current one).

Why I sort the ranges by their start points then I got wrong answer ? But sort the ranges by their end points will get AC ?

Any hint for problem H or L???

Problem H:

BFS off of every monster tile and only go a maximum of d distance away. Any tile that was touched by a monster's BFS is now no longer usable. Now BFS from your starting point and do regular shortest path in a grid but making sure to ignore cells touched by the monsters.

Problem L:

For every position

iin the string, find the next position of every letter in the alphabet. Now keep some kind of queue and find the next position of whatever letter is queried (or pop the back of your queue). If the next position of the queried letter doesn't exist, the answer is no otherwise it's yes.So simple BFS's were enough in H? I thought that with n*m up to 4*10^10 that would take too long, even just to calculate 'bad' cells

n*m≤ 2 * 10^{5}Oh.. I guess I can't read :(

Thanks, now it's a lot more clear

that's what i missed:(

For H，first i DFS for each 'M' finding which grid can't reach, then BFS for shortest path, but wrong answer on test 20，i really wanna know what test 20 data is,thx~

Go here

really useful!thx!

but test 20 can just see one line of data:(

Yeah I too got a WA on test 20 , but I don't know why this approach gives WA with dfs

Test 22 is here, most probably you can't pass it too.

Test 20 is the same but with other parameters:

Spoiler`n=m=447, d=10`

But can you help me out why, am I getting a wrong answer. Is doing dfs to find cells at distance d wrong?

Yep, it's definitely wrong. You may visit some cell with distance X <= M, and then, when you will try to visit it again with distance Y < X <= M, you will ignore that edge because cell already visited. So the fix is change visited array type from boolean to int (shortest distance from M to that cell), but in that case I think you may get stuck with TLE.

Yeah I encountered a TLE, with bfs

can someone explain why this code gives MLE (the queueis full ) i used bfs from all M then one bFS from s for path length https://pastebin.com/ip8Q1hH8 solved : I have to mark the node visited than added to the queue not the inverse

`What's output of problem E for this test case:`

`abaca`

`aabac`

The output is "NO"

What is the test 48 on F?

During the contest this test helps me:

Answer is NO

Any hints on how to approach I? My approach can't seem to get past test 12.

I used this approach:

Define a procedure

`findRoot(vertices, leafs, depth)`

for search a tree root among vertices, inside it we need to find two leafs from a different subtrees (relative to root). It can be managed in`O(size(vertices))`

, then you can easily find a root (it is a vertex, that`dist(leaf1, v) = dist(leaf2, v) = depth`

). Then you need to run findRoot recursively from left/right subtree.So, each findRoot procedure takes

`2 * size(vertices)`

queries (`2 * nlogn`

in total) and additional queries at start to find leafs.That makes a lot of sense. Thank you!

Hi, I can't figure it out how do you manage to classify vertex according to left and right subtree for the recursive call. Can you explain that part? Because you pass vertices and leafs parameters that, I guess, represent vertices and leafs of the current subtree.

Thanks

You have two leafs from different subtrees, so lets call them left & right. So to classify arbitrary vertex we need to compare dist(left, vertext) and dist(right, vertex) — if dist from vertex to left vertex smaller then vertex in a left subtree and vice versa.

Could you show me the code? I try many many ways but i still can't figure it out.

Thanks.

It's very easy to include interactor in the solution and test it locally. All tests for this problem are just trees with random-shuffled vertex indices (there are no any special cases). So it doesn't seem you "tried many many ways".

That's because I make too many queries then I get a wrong answer,but i have no idea how to reduce the query though I know my ways can restore the tree.

SpoilerSo you have leaf1 and leaf2 (leaf1-leaf2 is a diameter), find the root, divide all vertices into two sets: the ones which are closer to leaf1 and to leaf2. When you go deeper in recursion, the distances from leaf1 and leaf2 can be reused, since they are still leaves in the subtrees (it's done automatically if you cache the distances).

I got it. Thanks a lot.

What's test 22 on H ?

Test 22 generatorThe game .C.O.N.T.E.S.T: Unexpected Behaviour from Problem K "Video Reviews" does not exist. But recently our gamedev team Veslo Games released the game .T.E.S.T: Expected Behaviour (from creator of Codeforces Simulator!) to the Steam Early Access. If you like puzzles, consider checking this out!

is there a algorithm about problem M？or it's just a simulation？

Spoiler, MJust bruteforce. Try to set all letters on all critical positions (there are no more than 3 of them).

I thought it's like 4th or 5th easiest problem in the contest. But everyone gets stuck.

Can any body help me for problem C ?? I can not find the algorithm. And Why (2 _ 1 5 ) is a wrong answer on test_case 1 for problem C.

could anybody help me with the problom I, I can't pass the test 5

This test has n = 7 and random-shuffled vertices.

thanks a lot,but i'm stuck in test 12 now, trust me,i will figure it out :( lol

I am stuck on problem H 8-th test . Can I see the case I'm failing ?

Test Case 81 3 0

MSF

Jury's Answer: 1

Thanks

Can anyone provide any hints for problem K ,video reviews? thanks.

Main hint: binary search

thanks for replying.binary search i figured out but was not able to come up with a predicate.thanks.

Suppose we have X, and we need to check if X is enough to get m reviews. You need to process the bloggers from left to right. There are two options:

It can be easily proven that greedy algorithm works.

What is the test case 50 in problem F? I got stucked there :(

F, test 48Generate random tree, generate input for the problem, remove one number from one of the lists

F, test 50Generate random tree, generate input for the problem, add one number to one of the lists

Thanks, I don't know why my aproach was wrong. At the end I changed my strategy and get AC.

Do you have any hint for problem D? I belive that a maxflow algorithm could said if it is possible or not, but I can't construct the solution

Certificate in DI'll just leave an example. Let's say you need to exchange player 1 with player 6, and you have a path 1->2->3->4->5->6, where players 1 and 4 are in your team. Then we'll do two sequences of exchanges: the first is (4, 5) and (5, 6), and the second is (1, 2), (2, 3) and (3, 4). Now players 4 and 6 are in your team.

What is the test case 52 in problem F? I got stucked there.

The same as test 48 (see my comment above), but with different random seed

What's the approach for 'L — Queries on a String'? My current solution exceeds the memory limit at test 7.

Can someone that give hints about questions D, G and I ? I'm stuck on those.

May I get some help about 112 No. test case of problem No. F ???

The same as test 48 and 52 (see my comment above), but with different random seed

Problem H. Safe Path

WA on Test Case 124 :(

I am stuck.

Here's My Code:

https://codeforces.com/gym/101755/submission/48191879